<template>
    <div class="w-full mb-2 bg-gray-light rounded-lg pb-4 px-4" @vue:mounted="grabElement">
        <v-form
            ref="addressForm"
            :disabled="props.disabled"
            :readonly="props.readonly"
            validate-on="submit lazy"
            @submit.prevent
        >
            <v-row>
                <v-col cols="auto" :md="props.visibility.type ? `6` : ``" sm="6">
                    <v-select
                        v-if="props.visibility.type"
                        v-model="address.type"
                        :items="address.addressTypesDropdown"
                        item-title="label"
                        item-value="key"
                        :label="`${translate('labels.address')}  ${translate('labels.type')}`"
                        :rules="validator.setRules('required').validate()"
                        density="compact"
                        :disabled="address.typeKvk"
                        :menu-icon="props.selectMenuIcon"
                        @update:model-value="emitInputChange"
                    ></v-select>
                </v-col>

                <v-col cols="auto" :md="props.visibility.type ? `6` : `12`" sm="6">
                    <v-select
                        v-if="props.visibility.country_id"
                        v-model="address.country_id"
                        :items="countries"
                        :item-props="countryProps"
                        :label="translate('labels.country')"
                        :rules="validator.setRules('required').validate()"
                        density="compact"
                        :menu-icon="props.selectMenuIcon"
                        @update:model-value="emitInputChange"
                        @click:clear="clearInputs"
                        :disabled="validatorSettings.disabledFields.country || props.noValidate || address.typeKvk"
                        validate-on="blur"
                        @blur="onRequiredBlur"
                    ></v-select>
                </v-col>
            </v-row>

            <v-row>
                <!-- validator.setRules('regex:/^[\\pL\\s\\-]+$/u|max:255').validate() -->
                <v-col cols="12" sm="4">
                    <v-text-field
                        v-if="props.visibility.street"
                        v-model="address.street"
                        :label="translate('labels.street')"
                        :rules="validator.setRules('string|max:255').validate()"
                        density="compact"
                        required
                        @update:model-value="emitInputChange"
                        :disabled="validatorSettings.disabledFields.street || address.typeKvk"
                        validate-on="blur"
                        @blur="onRequiredBlur"
                    ></v-text-field>
                </v-col>
                <v-col cols="12" sm="4">
                    <!-- validator.setRules('numeric|integer|max:999999999').validate() -->
                    <v-text-field
                        v-if="props.visibility.streetNumber"
                        v-model="address.streetNumber"
                        :label="translate('labels.street_number')"
                        :rules="validator.setRules('numeric|integer|max:999999999').validate()"
                        density="compact"
                        required
                        @update:model-value="emitInputChange"
                        :disabled="validatorSettings.disabledFields.streetNumber || address.typeKvk"
                        validate-on="blur"
                        @blur="onRequiredBlur"
                    ></v-text-field>
                </v-col>
                <v-col cols="12" sm="4">
                    <!-- validator.setRules('alpha_num|max:16').validate(true) -->
                    <v-text-field
                        v-if="props.visibility.streetNumberExtension"
                        v-model="address.streetNumberExtension"
                        :label="translate('labels.street_number_extension')"
                        :rules="validator.setRules('string|max:16').validate() || undefined"
                        density="compact"
                        @update:model-value="emitInputChange"
                        :disabled="validatorSettings.disabledFields.streetNumberExtension || address.typeKvk"
                        validate-on="blur"
                        @blur="onRequiredBlur"
                    ></v-text-field>
                </v-col>
            </v-row>
            <v-row>
                <v-col cols="12" sm="6">
                    <v-text-field
                        v-if="props.visibility.city"
                        v-model="address.city"
                        :label="translate('labels.city')"
                        :rules="validator.setRules('string|max:255').validate()"
                        density="compact"
                        @update:model-value="emitInputChange"
                        :disabled="validatorSettings.disabledFields.city || address.typeKvk"
                        validate-on="blur"
                        @blur="onRequiredBlur"
                    ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6">
                    <v-text-field
                        v-if="props.visibility.postCode"
                        v-model="address.postCode"
                        :label="translate('labels.post_code')"
                        :rules="validator.setRules('alpha_num|alpha_dash|max:32').validate()"
                        density="compact"
                        required
                        @update:model-value="emitInputChange"
                        :disabled="validatorSettings.disabledFields.postCode || address.typeKvk"
                        validate-on="blur"
                        @blur="onRequiredBlur"
                        @keydown="trimPostCodeSpaces"
                        @paste.prevent
                    ></v-text-field>
                </v-col>
            </v-row>
            <v-row>
                <v-col cols="12" sm="8"></v-col>
                <v-col cols="12" sm="4">
                    <div
                        class="flex justify-endaddress-validation-status d-flex align-end flex-column"
                        v-if="validatorSettings.statusVisible"
                    >
                        <v-btn
                            class="btn-validation"
                            density="default"
                            :loading="validatorSettings.inProgress"
                            variant="tonal"
                            :color="currentColor"
                            :prepend-icon="currentIcon"
                            @click="validate"
                        >
                            {{ currentLabel }}
                            <v-tooltip activator="parent" location="start">{{ currentTooltip }}</v-tooltip>
                        </v-btn>
                    </div>
                </v-col>
            </v-row>
        </v-form>
        <slot><br /></slot>
    </div>
</template>

<script setup lang="ts">
import {
    defineEmits,
    defineProps,
    onBeforeMount,
    onMounted,
    onErrorCaptured,
    ref,
    watch,
    getCurrentInstance,
} from 'vue';
import { useI18n } from 'vue-i18n';
import { storeFactory } from '@/main';
import { ValidationStatusEnum } from '@/enums/validationStatusEnum';
import { hasApiValidation, ValidateAddress } from '@/helpers/strategy/ValidationStrategy';
import { isValidationResponseType } from '@/types/stores/validationStoreTypes';
import { EntityStatusEnum } from '@/enums/entityStatusEnum';
import { Validator } from '@/helpers/Validator';

import type { AddressValidationResponseType } from '@/types/stores/validationStoreTypes';
import type { AddressPayloadInterface } from '@/helpers/AutocompleteCall';

const emit = defineEmits(['update:address', 'validated:address']);

const { t: translate } = useI18n();

const configStore = storeFactory.configStore;
const countryStore = storeFactory.countryStore;
const validationStore = storeFactory.validationStore;

const countries = ref([]);
const validator = new Validator();

const props = defineProps({
    _entity_status: {
        type: String, // EntityStatusEnum
        default: EntityStatusEnum.NEW,
    },
    title: {
        type: String,
        default: '',
    },
    icon: {
        type: String,
        default: '',
    },
    disabled: {
        type: Boolean,
        default: true,
    },
    readonly: {
        type: Boolean,
        default: true,
    },
    noValidate: {
        type: Boolean,
        default: true,
    },
    selectMenuIcon: {
        type: String,
    },
    availableTypes: {},
    addressTypesDropdown: {},
    id: {
        type: Number,
        default: null,
    },
    type: {
        type: String,
    },
    active: {
        type: Boolean,
        default: false,
    },
    loading: {
        type: Boolean,
        default: false,
    },
    street: {
        type: String,
    },
    street_number: {
        type: String,
    },
    street_number_extension: {
        type: String,
    },
    city: {
        type: String,
    },
    post_code: {
        type: String,
    },
    type_kvk: {
        type: Boolean,
        default: false,
    },
    country_id: {},
    visibility: {
        type: Object,
        default() {
            return {
                type: true,
                street: true,
                streetNumber: true,
                streetNumberExtension: true,
                city: true,
                postCode: true,
                country_id: true,
            };
        },
    },
});

const transferProps = (p: any) => {
    return {
        _entity_status: p._entity_status,
        id: p.id,
        type: p.type,
        street: p.street,
        streetNumber: p.street_number,
        streetNumberExtension: p.street_number_extension,
        city: p.city,
        postCode: p.post_code,
        typeKvk: p.type_kvk,
        country_id: p.country_id,
        disabled: p.disabled,
        noValidate: p.noValidate,
        availableTypes: p.availableTypes,
        addressTypesDropdown: p.addressTypesDropdown,
    };
};
const currentComponentKey = getCurrentInstance()?.vnode.key;

const addressForm = ref(null) as any;
const address = ref(transferProps(props));
const componentId = ref(props.id);
const isExisting = ref(props.id && props.id > 0);
const isValidatingOnLoad = ref(false);

const countryProps = (country: any) => ({
    title: translate(`countries.${country.slug}`),
    value: country.id,
});

onBeforeMount(async () => {
    await Promise.all([initializeCountries()]);
});

onMounted(async () => {
    // address
    if (props.disabled || props.noValidate) {
        lockAll();
    }

    setStatusNotValidated(); // optionally run validation on mount, validation will run on submit anyway
    lockPreloadedFromApi();
});

onErrorCaptured(() => {
    if (validatorSettings.value.inProgress) {
        validatorSettings.value.inProgress = false;
        setStatusNotValidated();
    }
});

// TODO: colors and icons to configStore, once we know what kind of design we want
const validatorSettings = ref({
    cardColor: 'light',
    cardVariant: 'elevated',

    isValid: null,
    inProgress: false,
    autoValidate: true,
    validateOn: 'blur',
    currentStatus: ValidationStatusEnum.STATUS_INVALID,

    notValidatedLabel: translate('validation.statuses.not_validated'),
    notValidatedIcon: 'mdi-close-thick',
    notValidatedColor: 'blue-grey-lighten-3',

    inProgressLabel: translate('validation.statuses.in_progress'),
    inProgressIcon: 'mdi-clock-alert-outline',
    inProgressColor: 'blue-grey-lighten-3',

    invalidLabel: translate('validation.statuses.invalid'),
    invalidIcon: 'mdi-close-thick',
    invalidColor: 'red-accent-4',

    validLabel: translate('validation.statuses.valid'),
    validIcon: 'mdi-check-bold',
    validColor: 'green-darken-3',

    validatedLabel: translate('validation.statuses.validated'),
    didNotRunLabel: translate('validation.validation_did_not_run_yet'),

    statusVisible: false,

    disabledFields: {
        country: false,
        street: false,
        streetNumber: false,
        streetNumberExtension: false,
        city: false,

        postCode: false,
    },
});

let currentLabel = ref(validatorSettings.value.notValidatedLabel);
let currentIcon = ref(validatorSettings.value.notValidatedIcon);
let currentColor = ref(validatorSettings.value.notValidatedIcon);
let currentTooltip = ref(validatorSettings.value.didNotRunLabel);

watch(props, (p) => {
    // in case of address removal, shift data within a loop
    refreshProps(p);
});

const refreshProps = (currentProps: any) => {
    address.value = transferProps(currentProps);
};

const emitInputChange = () => {
    emitDataChange();

    unlockInputs();
    setStatusNotValidated();
    emitValidationChange(false);
};

const emitFillingIn = () => {
    validatorSettings.value.statusVisible = true;

    if (validatorSettings.value.inProgress) setStatusNotValidated();
    if (validatorSettings.value.isValid) emitValidationChange(validatorSettings.value.isValid);

    emitDataChange();
};

const emitDataChange = () => {
    if (address.value._entity_status !== EntityStatusEnum.ORIGINAL) {
        address.value._entity_status = address.value.id ? EntityStatusEnum.CHANGED : EntityStatusEnum.NEW;
    }

    const updatedAddress = { ...address.value };

    emit('update:address', updatedAddress);
};

const emitValidationChange = (isValid: boolean) => {
    emit('validated:address', isValid);
};

const initializeCountries = async () => {
    if (countryStore.getCountries().length === 0) {
        await countryStore.searchCountries().then((result) => {
            countries.value.push(result.items);
        });
    } else {
        countries.value = countryStore.getCountries();
    }
};

const trimPostCodeSpaces = () => {
    if (address.value.postCode) {
        address.value.postCode = address.value.postCode.toString().toUpperCase().replace(' ', '');
    }
};

const onRequiredBlur = () => {
    trimPostCodeSpaces();

    if (props.noValidate) {
        return;
    }

    if (!hasAllRequiredToValidate()) {
        setStatusInvalid();
        return;
    }

    validate();
};

const hasAllRequiredToValidate = () => {
    return address.value.country_id && address.value.postCode && address.value.postCode.length > 3;
};

const validate = async () => {
    if (props.noValidate) {
        return;
    }

    setStatusInProgress();
    const selectedCountry =
        countries.value && countries.value.find((country: any) => country.id === address.value.country_id);

    if (!selectedCountry) {
        setStatusInvalid(translate('validation.address.hints.please_select_a_country')); // hint for tooltip
        return false;
    }

    if (isNaN(Number(address.value.streetNumber))) {
        setStatusInvalid(translate('validation.address.hints.street_number_must_be_a_number')); // hint for tooltip
        return false;
    }

    const payload: AddressPayloadInterface = {
        iso: selectedCountry.iso.toLowerCase(),
        city: address.value.city,
        postal_code: address.value.postCode,
        street: address.value.street,
        street_number: address.value.streetNumber,
        extension: address.value.streetNumberExtension,
    };

    return await new ValidateAddress(validationStore, addressForm, payload)
        .setApiCallStatus(configStore.apiValidationSettings.isIgnoringAddressApi)
        .run()
        .then((response: AddressValidationResponseType | any) => {
            unlockInputs();
            if (isValidationResponseType(response)) {
                fill(response);
            }

            validatorSettings.value.statusVisible = true;
            return validatorSettings.value.isValid;
        })
        .catch((error: any) => {
            if (isValidationResponseType(error)) {
                setStatusInvalid(error.message); // e.g. missing fields
            } else {
                setStatusInvalid(translate('validation.statuses.invalid'));
                console.error(error);
            }

            validatorSettings.value.statusVisible = true;
            return validatorSettings.value.isValid;
        })
        .finally(() => {
            // autofilled street and city
            emitFillingIn();
        });
};

const fill = (response: AddressValidationResponseType) => {
    if (response.hasApi) {
        lockInputs();
        fillData(response);
    }

    updateStatus(response.status, response.message);
};
const fillData = (response: AddressValidationResponseType) => {
    address.value.street = response.data.street;
    address.value.city = response.data.city;
};

const lockInputs = () => {
    validatorSettings.value.disabledFields.street = true;
    validatorSettings.value.disabledFields.city = true;
};
const lockAll = () => {
    setColorsLocked();

    validatorSettings.value.disabledFields.street = true;
    validatorSettings.value.disabledFields.streetNumber = true;
    validatorSettings.value.disabledFields.streetNumberExtension = true;
    validatorSettings.value.disabledFields.city = true;
    validatorSettings.value.disabledFields.postCode = true;

    validatorSettings.value.statusVisible = false;
};
const unlockInputs = () => {
    setColorsNormal();

    validatorSettings.value.disabledFields.street = false;
    validatorSettings.value.disabledFields.streetNumber = false;
    validatorSettings.value.disabledFields.streetNumberExtension = false;
    validatorSettings.value.disabledFields.city = false;
    validatorSettings.value.disabledFields.postCode = false;

    validatorSettings.value.statusVisible = true;
};

const clearInputs = () => {
    setStatusNotValidated();

    address.value.street = '';
    address.value.streetNumber = '';
    address.value.streetNumberExtension = '';
    address.value.city = '';
    address.value.postCode = '';
};

const lockPreloadedFromApi = () => {
    const preloadedCountry = props.country_id ? countryStore.getCountryById(props.country_id) : null;
    if (preloadedCountry && preloadedCountry.iso && hasApiValidation(preloadedCountry.iso)) {
        //setStatusValid();
        lockInputs();
    }
};

const updateStatus = (status: string | any, message?: string | any) => {
    switch (status) {
        case ValidationStatusEnum.STATUS_VALID: {
            setStatusValid();
            break;
        }
        case ValidationStatusEnum.STATUS_INVALID: {
            setStatusInvalid(message);
            break;
        }
        default: {
            setStatusNotValidated();
            break;
        }
    }
};

const setStatusNotValidated = () => {
    currentTooltip.value = validatorSettings.value.didNotRunLabel;
    currentlabels.value = validatorSettings.value.notValidatedLabel;
    currentIcon.value = validatorSettings.value.notValidatedIcon;
    currentColor.value = validatorSettings.value.notValidatedColor;

    validatorSettings.value.inProgress = false;
    validatorSettings.value.statusVisible = false;
};

const setStatusInProgress = () => {
    currentTooltip.value = validatorSettings.value.inProgressLabel;
    currentlabels.value = validatorSettings.value.inProgressLabel;
    currentIcon.value = validatorSettings.value.inProgressIcon;
    currentColor.value = validatorSettings.value.inProgressColor;

    validatorSettings.value.inProgress = true;
    validatorSettings.value.statusVisible = true;
    setColorsNormal();
};

const setStatusValid = () => {
    currentTooltip.value = validatorSettings.value.validatedLabel;
    currentlabels.value = validatorSettings.value.validLabel;
    currentIcon.value = validatorSettings.value.validIcon;
    currentColor.value = validatorSettings.value.validColor;

    validatorSettings.value.inProgress = false;
    validatorSettings.value.isValid = true;
    validatorSettings.value.statusVisible = true;

    hideErrors();
    setColorsNormal();
};

const setStatusInvalid = (message?: string | any) => {
    currentTooltip.value = message ?? validatorSettings.value.invalidLabel;
    currentlabels.value = validatorSettings.value.invalidLabel;
    currentIcon.value = validatorSettings.value.invalidIcon;
    currentColor.value = validatorSettings.value.invalidColor;

    validatorSettings.value.inProgress = false;
    validatorSettings.value.isValid = false;
    validatorSettings.value.statusVisible = true;

    setColorsError();
};

const hideErrors = () => {
    if (addressForm.value) addressForm.value.resetValidation();
};

const setColorsNormal = () => {
    validatorSettings.value.cardColor = 'light';
    validatorSettings.value.cardVariant = 'elevated';
};

const setColorsLocked = () => {
    validatorSettings.value.cardColor = 'light';
    validatorSettings.value.cardVariant = 'elevated'; // tonal?
};

const setColorsError = () => {
    validatorSettings.value.cardColor = 'error';
    validatorSettings.value.cardVariant = 'outlined';
};

const key = currentComponentKey;
const entityId = componentId.value;
const isNew = isExisting.value !== true;
const canBeValidated = true;
const element = ref(null);

const grabElement = (el: any) => {
    element.value = el.el;
};

export interface AddressComponentRefData {
    key?: string | undefined;
    isNew?: boolean | undefined;
    canBeValidated?: boolean | undefined;
    entityId?: number | undefined;
    validate: object;
}

defineExpose({ key, isNew, canBeValidated, entityId, element, validate } as AddressComponentRefData);
</script>
<style>
html body .v-theme--light {
    --v-disabled-opacity: 1;
}

.address-validation-status .btn-validation {
    opacity: 0.3;
    cursor: auto;
}
</style>
